2 ############################################################################
4 # This file is part of the IPFire Firewall. #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
20 # Copyright (C) 2007-2020 IPFire Team <info@ipfire.org>. #
22 ############################################################################
25 NAME
="IPFire" # Software name
26 SNAME
="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION
="2.25" # Version number
29 CORE
="152" # Core Level (Filename)
30 SLOGAN
="www.ipfire.org" # Software slogan
31 CONFIG_ROOT
=/var
/ipfire
# Configuration rootdir
33 MAX_RETRIES
=1 # prefetch/check loop
34 BUILD_IMAGES
=1 # Flash and Xen Downloader
35 KVER
=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
37 # Information from Git
38 GIT_BRANCH
="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
39 GIT_TAG
="$(git tag | tail -1)" # Git Tag
40 GIT_LASTCOMMIT
="$(git rev-parse --verify HEAD)" # Last commit
44 ###############################################################################
46 # Beautifying variables & presentation & input output interface
48 ###############################################################################
50 # Remember if the shell is interactive or not
51 if [ -t 0 ] && [ -t 1 ]; then
57 # Sets or adjusts pretty formatting variables
60 # Find current screen size
63 # When using remote connections, such as a serial port, stty size returns 0
64 if ! ${INTERACTIVE} ||
[ "${COLUMNS}" = "0" ]; then
68 # Measurements for positioning result messages
72 NAME_WIDTH
=$
(( COLUMNS
- OPTIONS_WIDTH
- TIME_WIDTH
- STATUS_WIDTH
))
73 LINE_WIDTH
=$
(( COLUMNS
- STATUS_WIDTH
))
75 TIME_COL
=$
(( NAME_WIDTH
+ OPTIONS_WIDTH
))
76 STATUS_COL
=$
(( TIME_COL
+ TIME_WIDTH
))
79 # Initially setup terminal
82 # Call resize_terminal when terminal is being resized
83 trap "resize_terminal" WINCH
85 # Define color for messages
93 # New architecture variables
94 HOST_ARCH
="$(uname -m)"
97 BASENAME
=$
(basename $0)
99 # Debian specific settings
100 if [ ! -e /etc
/debian_version
]; then
103 if [ -x /usr
/bin
/realpath
]; then
104 FULLPATH
=`/usr/bin/realpath $0`
106 echo "ERROR: Need to do apt-get install realpath"
111 # This is the directory where make.sh is in
112 export BASEDIR
=$
(echo $FULLPATH |
sed "s/\/$BASENAME//g")
114 LOGFILE
=$BASEDIR/log
/_build.preparation.log
116 DIR_CHK
=$BASEDIR/cache
/check
117 mkdir
$BASEDIR/log
/ 2>/dev
/null
119 system_processors
() {
120 getconf _NPROCESSORS_ONLN
2>/dev
/null ||
echo "1"
126 while read -r key val unit
; do
130 echo "$(( ${val} / 1024 ))"
138 local build_arch
="${1}"
140 if [ "${build_arch}" = "default" ]; then
141 build_arch
="$(configure_build_guess)"
144 case "${build_arch}" in
146 BUILDTARGET
="${build_arch}-unknown-linux-gnu"
147 CROSSTARGET
="${build_arch}-cross-linux-gnu"
149 CFLAGS_ARCH
="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
153 BUILDTARGET
="${build_arch}-pc-linux-gnu"
154 CROSSTARGET
="${build_arch}-cross-linux-gnu"
156 CFLAGS_ARCH
="-march=i586 -mtune=generic -fomit-frame-pointer"
160 BUILDTARGET
="${build_arch}-unknown-linux-gnu"
161 CROSSTARGET
="${build_arch}-cross-linux-gnu"
163 CFLAGS_ARCH
="-fstack-clash-protection"
167 BUILDTARGET
="${build_arch}-unknown-linux-gnueabi"
168 CROSSTARGET
="${build_arch}-cross-linux-gnueabi"
170 CFLAGS_ARCH
="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
174 BUILDTARGET
="${build_arch}-unknown-linux-gnueabi"
175 CROSSTARGET
="${build_arch}-cross-linux-gnueabi"
177 CFLAGS_ARCH
="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
178 RUSTFLAGS
="-Ccodegen-units=1"
182 exiterror
"Cannot build for architure ${build_arch}"
186 # Check if the QEMU helper is available if needed.
187 if qemu_is_required
"${build_arch}"; then
188 local qemu_build_helper
="$(qemu_find_build_helper_name "${build_arch}")"
190 if [ -n "${qemu_build_helper}" ]; then
191 QEMU_TARGET_HELPER
="${qemu_build_helper}"
193 exiterror
"Could not find a binfmt_misc helper entry for ${build_arch}"
197 BUILD_ARCH
="${build_arch}"
198 TOOLS_DIR
="/tools_${BUILD_ARCH}"
201 HARDENING_CFLAGS
="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
203 CFLAGS
="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
206 # Determine parallelism
207 # We assume that each process consumes about
208 # 128MB of memory. Therefore we find out how
209 # many processes fit into memory.
210 local mem_max
=$
(( ${SYSTEM_MEMORY} / 128 ))
211 local cpu_max
=$
(( ${SYSTEM_PROCESSORS} + 1 ))
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism
=${mem_max}
217 parallelism
=${cpu_max}
220 # Use this as default PARALLELISM
221 DEFAULT_PARALLELISM
="${parallelism}"
223 # Compression parameters
224 # We use mode 8 for reasonable memory usage when decompressing
225 # but with overall good compression
228 # We try to use as many cores as possible
229 XZ_OPT
="${XZ_OPT} -T0"
231 # We need to limit memory because XZ uses too much when running
232 # in parallel and it isn't very smart in limiting itself.
233 # We allow XZ to use up to 70% of all system memory.
234 local xz_memory
=$
(( SYSTEM_MEMORY
* 7 / 10 ))
236 # XZ memory cannot be larger than 2GB on 32 bit systems
237 case "${build_arch}" in
239 if [ ${xz_memory} -gt 2048 ]; then
245 XZ_OPT
="${XZ_OPT} --memory=${xz_memory}MiB"
248 configure_build_guess
() {
249 case "${HOST_ARCH}" in
261 armv7
*|armv6
*|armv5
*)
266 exiterror
"Cannot guess build architecture"
272 umount
$BASEDIR/build
/sys
2>/dev
/null
;
273 umount
$BASEDIR/build
/dev
/shm
2>/dev
/null
;
274 umount
$BASEDIR/build
/dev
/pts
2>/dev
/null
;
275 umount
$BASEDIR/build
/dev
2>/dev
/null
;
276 umount
$BASEDIR/build
/proc
2>/dev
/null
;
277 umount
$BASEDIR/build
/install
/mnt
2>/dev
/null
;
278 umount
$BASEDIR/build
/usr
/src
/cache
2>/dev
/null
;
279 umount
$BASEDIR/build
/usr
/src
/ccache
2>/dev
/null
;
280 umount
$BASEDIR/build
/usr
/src
/config
2>/dev
/null
;
281 umount
$BASEDIR/build
/usr
/src
/doc
2>/dev
/null
;
282 umount
$BASEDIR/build
/usr
/src
/html
2>/dev
/null
;
283 umount
$BASEDIR/build
/usr
/src
/langs
2>/dev
/null
;
284 umount
$BASEDIR/build
/usr
/src
/lfs
2>/dev
/null
;
285 umount
$BASEDIR/build
/usr
/src
/log
2>/dev
/null
;
286 umount
$BASEDIR/build
/usr
/src
/src
2>/dev
/null
;
287 umount
$BASEDIR/build
/usr
/src
2>/dev
/null
;
288 umount
$BASEDIR/build
/tmp
2>/dev
/null
;
298 if [ ${seconds} -ge 3600 ]; then
299 printf "%d:%02d:%02d\n" \
300 "$(( seconds / 3600 ))" \
301 "$(( seconds % 3600 / 60 ))" \
302 "$(( seconds % 3600 % 60 ))"
303 elif [ ${seconds} -ge 60 ]; then
305 "$(( seconds / 60 ))" \
306 "$(( seconds % 60 ))"
308 printf "%d\n" "${seconds}"
315 printf "%-${LINE_WIDTH}s" "${line}"
322 if ${INTERACTIVE}; then
328 if ${INTERACTIVE}; then
334 _print_line BOLD
"$@"
338 _print_line FAIL
"$@"
345 local version
="$(grep -E "^VER |^VER
=|^VER
" $BASEDIR/lfs/${name} | awk '{ print $3 }')"
348 local string
="${name}"
349 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
350 string
="${string} (${version})"
353 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
354 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
358 local runtime
=$
(format_runtime $@
)
360 if ${INTERACTIVE}; then
361 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
363 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
370 local color
="${!status}"
372 if ${INTERACTIVE}; then
373 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
375 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
379 print_build_stage
() {
386 print_build_summary
() {
387 local runtime
=$
(format_runtime $@
)
389 print_line
"*** Build finished in ${runtime}"
395 for i
in `seq 0 7`; do
396 if ( losetup
/dev
/loop
${i} 2>/dev
/null |
grep -q "/install/images" ); then
397 losetup
-d /dev
/loop
${i} 2>/dev
/null
402 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
406 while read -r line
; do
408 done <<< "$(tail -n30 ${LOGFILE})"
414 for line
in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
415 print_error
"${line}"
423 # Are we running the right shell?
424 if [ -z "${BASH}" ]; then
425 exiterror
"BASH environment variable is not set. You're probably running the wrong shell."
428 if [ -z "${BASH_VERSION}" ]; then
429 exiterror
"Not running BASH shell."
432 # Trap on emergency exit
433 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
435 # Resetting our nice level
436 if ! renice
${NICE} $$
>/dev
/null
; then
437 exiterror
"Failed to set nice level to ${NICE}"
440 # Checking if running as root user
441 if [ $
(id
-u) -ne 0 ]; then
442 exiterror
"root privileges required for building"
445 # Checking for necessary temporary space
446 print_line
"Checking for necessary space on disk $BASE_DEV"
447 BASE_DEV
=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
448 BASE_ASPACE
=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
449 if (( 2048000 > $BASE_ASPACE )); then
450 BASE_USPACE
=`du -skx $BASEDIR | awk '{print $1}'`
451 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
453 exiterror
"Not enough temporary space available, need at least 2GB on $BASE_DEV"
468 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
469 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
471 # Make some extra directories
472 mkdir
-p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev
/null
473 mkdir
-p $BASEDIR/build
/{etc
,usr
/src
} 2>/dev
/null
474 mkdir
-p $BASEDIR/build
/{dev
/{shm
,pts
},proc
,sys
}
475 mkdir
-p $BASEDIR/{cache
,ccache
/${BUILD_ARCH}} 2>/dev
/null
477 if [ "${ENABLE_RAMDISK}" = "on" ]; then
478 mkdir
-p $BASEDIR/build
/usr
/src
479 mount
-t tmpfs tmpfs
-o size
=8G
,nr_inodes
=1M
,mode
=1777 $BASEDIR/build
/usr
/src
481 mkdir
-p ${BASEDIR}/build
/tmp
482 mount
-t tmpfs tmpfs
-o size
=4G
,nr_inodes
=1M
,mode
=1777 ${BASEDIR}/build
/tmp
485 mkdir
-p $BASEDIR/build
/usr
/src
/{cache
,config
,doc
,html
,langs
,lfs
,log
,src
,ccache
}
487 mknod
-m 600 $BASEDIR/build
/dev
/console c
5 1 2>/dev
/null
488 mknod
-m 666 $BASEDIR/build
/dev
/null c
1 3 2>/dev
/null
490 # Make all sources and proc available under lfs build
491 mount
--bind /dev
$BASEDIR/build
/dev
492 mount
--bind /dev
/pts
$BASEDIR/build
/dev
/pts
493 mount
--bind /dev
/shm
$BASEDIR/build
/dev
/shm
494 mount
--bind /proc
$BASEDIR/build
/proc
495 mount
--bind /sys
$BASEDIR/build
/sys
496 mount
--bind $BASEDIR/cache
$BASEDIR/build
/usr
/src
/cache
497 mount
--bind $BASEDIR/ccache
/${BUILD_ARCH} $BASEDIR/build
/usr
/src
/ccache
498 mount
--bind $BASEDIR/config
$BASEDIR/build
/usr
/src
/config
499 mount
--bind $BASEDIR/doc
$BASEDIR/build
/usr
/src
/doc
500 mount
--bind $BASEDIR/html
$BASEDIR/build
/usr
/src
/html
501 mount
--bind $BASEDIR/langs
$BASEDIR/build
/usr
/src
/langs
502 mount
--bind $BASEDIR/lfs
$BASEDIR/build
/usr
/src
/lfs
503 mount
--bind $BASEDIR/log
$BASEDIR/build
/usr
/src
/log
504 mount
--bind $BASEDIR/src
$BASEDIR/build
/usr
/src
/src
506 # Run LFS static binary creation scripts one by one
507 export CCACHE_DIR
=$BASEDIR/ccache
508 export CCACHE_TEMPDIR
="/tmp"
509 export CCACHE_COMPRESS
=1
510 export CCACHE_COMPILERCHECK
="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
512 # Remove pre-install list of installed files in case user erase some files before rebuild
513 rm -f $BASEDIR/build
/usr
/src
/lsalr
2>/dev
/null
515 # Prepare string for /etc/system-release.
516 local system_release
="${NAME} ${VERSION} (${BUILD_ARCH})"
518 case "${GIT_BRANCH}" in
520 system_release
="${system_release} - ${GIT_BRANCH}"
523 system_release
="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
527 # Append -dirty tag for local changes
528 if [ "$(git status -s | wc -l)" != "0" ]; then
529 system_release
="${system_release}-dirty"
533 SYSTEM_RELEASE
="${system_release}"
535 # Decide on PAKFIRE_TREE
536 case "${GIT_BRANCH}" in
538 PAKFIRE_TREE
="stable"
541 PAKFIRE_TREE
="testing"
544 PAKFIRE_TREE
="unstable"
548 # Setup ccache cache size
549 enterchroot ccache
--max-size="${CCACHE_CACHE_SIZE}" >/dev
/null
553 # Install QEMU helper, if needed
556 local PATH
="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
558 PATH
="${PATH}" chroot
${LFS} env
-i \
563 SYSTEM_RELEASE
="${SYSTEM_RELEASE}" \
564 PAKFIRE_TREE
="${PAKFIRE_TREE}" \
567 VERSION
="${VERSION}" \
570 TOOLS_DIR
="${TOOLS_DIR}" \
571 CONFIG_ROOT
="${CONFIG_ROOT}" \
572 CFLAGS
="${CFLAGS} ${HARDENING_CFLAGS}" \
573 CXXFLAGS
="${CXXFLAGS} ${HARDENING_CFLAGS}" \
574 RUSTFLAGS
="${RUSTFLAGS}" \
575 BUILDTARGET
="${BUILDTARGET}" \
576 CROSSTARGET
="${CROSSTARGET}" \
577 BUILD_ARCH
="${BUILD_ARCH}" \
578 BUILD_PLATFORM
="${BUILD_PLATFORM}" \
579 CCACHE_DIR
=/usr
/src
/ccache \
580 CCACHE_TEMPDIR
="${CCACHE_TEMPDIR}" \
581 CCACHE_COMPRESS
="${CCACHE_COMPRESS}" \
582 CCACHE_COMPILERCHECK
="${CCACHE_COMPILERCHECK}" \
583 GOCACHE
="/usr/src/ccache/go" \
586 DEFAULT_PARALLELISM
="${DEFAULT_PARALLELISM}" \
587 SYSTEM_PROCESSORS
="${SYSTEM_PROCESSORS}" \
588 SYSTEM_MEMORY
="${SYSTEM_MEMORY}" \
595 if [ ! -e $BASEDIR/build
/usr
/src
/lfs
/ ]; then
596 exiterror
"No such file or directory: $BASEDIR/build/usr/src/lfs/"
599 echo "Entering to a shell inside LFS chroot, go out with exit"
600 local PS1
="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
602 if enterchroot bash
-i; then
606 exiterror
"chroot error"
610 lfsmakecommoncheck
() {
612 if [ ! -f $BASEDIR/lfs
/$1 ]; then
613 exiterror
"No such file or directory: $BASEDIR/$1"
616 # Print package name and version
619 # Check if this package is supported by our architecture.
620 # If no SUP_ARCH is found, we assume the package can be built for all.
621 if grep "^SUP_ARCH" ${BASEDIR}/lfs
/${1} >/dev
/null
; then
622 # Check if package supports ${BUILD_ARCH} or all architectures.
623 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
632 for i in $SKIP_PACKAGE_LIST
634 if [ "$i" == "$1" ]; then
640 echo -ne "`date -u '+%b %e %T'`: Building $
* " >> $LOGFILE
642 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
643 MESSAGE="$1\t " download >> $LOGFILE 2>&1
644 if [ $? -ne 0 ]; then
645 exiterror "Download error
in $1"
648 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
649 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
650 if [ $? -ne 0 ]; then
651 exiterror "md5sum error
in $1, check
file in cache or signature
"
658 lfsmakecommoncheck $*
659 [ $? == 1 ] && return 0
661 cd $BASEDIR/lfs && env -i \
662 PATH="${TOOLS_DIR}/ccache
/bin
:${TOOLS_DIR}/bin
:$PATH" \
663 CCACHE_DIR="${CCACHE_DIR}" \
664 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
665 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
666 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
668 CXXFLAGS="${CXXFLAGS}" \
669 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
670 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
671 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
674 TOOLS_DIR="${TOOLS_DIR}" \
675 CROSSTARGET="${CROSSTARGET}" \
676 BUILDTARGET="${BUILDTARGET}" \
677 BUILD_ARCH="${BUILD_ARCH}" \
678 BUILD_PLATFORM="${BUILD_PLATFORM}" \
679 LFS_BASEDIR="${BASEDIR}" \
682 install >> $LOGFILE 2>&1 &
684 if ! wait_until_finished $!; then
686 exiterror "Building $
*"
693 lfsmakecommoncheck $*
694 [ $? == 1 ] && return 0
699 ${EXTRA_PATH}bash -x -c "cd /usr
/src
/lfs
&& \
701 LFS_BASEDIR
=/usr
/src
install" \
704 if ! wait_until_finished $!; then
706 exiterror "Building $
*"
713 lfsmakecommoncheck $*
714 [ $? == 1 ] && return 0
719 bash -x -c "cd /usr
/src
/lfs
&& make -f $
* LFS_BASEDIR
=/usr
/src dist
" \
722 if ! wait_until_finished $!; then
724 exiterror "Packaging $
*"
730 wait_until_finished() {
733 local start_time=$(now)
736 if ${INTERACTIVE}; then
737 # Wait a little just in case the process
738 # has finished very quickly.
742 while kill -0 ${pid} 2>/dev/null; do
743 print_runtime $(( $(now) - ${start_time} ))
750 # Returns the exit code of the child process
754 if ! ${INTERACTIVE}; then
755 print_runtime $(( $(now) - ${start_time} ))
762 [ -e "${BASEDIR}/build
${TOOLS_DIR}/lib
/libpakfire_preload.so
" ] || return
764 local env="LD_PRELOAD
=${TOOLS_DIR}/lib
/libpakfire_preload.so
"
766 # Fake kernel version, because some of the packages do not compile
767 # with kernel 3.0 and later.
768 env="${env} UTS_RELEASE
=${KVER}-ipfire"
770 # Fake machine version.
771 env="${env} UTS_MACHINE
=${BUILD_ARCH}"
779 # Don't add anything if qemu is not used.
780 if ! qemu_is_required; then
784 # Set default qemu options
785 case "${BUILD_ARCH}" in
787 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
789 env="${env} QEMU_CPU
=${QEMU_CPU}"
794 #env="${env} QEMU_STRACE
=1"
800 local build_arch="${1}"
802 if [ -z "${build_arch}" ]; then
803 build_arch="${BUILD_ARCH}"
806 case "${HOST_ARCH},${build_arch}" in
807 x86_64,arm*|x86_64,aarch64|i?86,arm*|i?86,aarch64|i?86,x86_64)
816 qemu_install_helper() {
817 # Do nothing, if qemu is not required
818 if ! qemu_is_required; then
822 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
823 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable.
"
826 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
827 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable.
"
831 if [ -z "${QEMU_TARGET_HELPER}" ]; then
832 exiterror "QEMU_TARGET_HELPER not
set"
835 # Check if the helper is already installed.
836 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
840 # Try to find a suitable binary that we can install
841 # to the build environment.
843 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
844 # file must exist and be executable.
845 [ -x "${file}" ] || continue
848 file_is_static "${file}" || continue
850 local dirname="${LFS}$
(dirname "${file}")"
851 mkdir -p "${dirname}"
853 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
857 exiterror "Could not
find a statically-linked QEMU emulator
: ${QEMU_TARGET_HELPER}"
860 qemu_find_build_helper_name() {
861 local build_arch="${1}"
864 case "${build_arch}" in
866 magic="7f454c460201010000000000000000000200b700
"
869 magic="7f454c4601010100000000000000000002002800
"
872 magic="7f454c4602010100000000000000000002003e00
"
876 [ -z "${magic}" ] && return 1
879 for file in /proc/sys/fs/binfmt_misc/*; do
880 # skip write only register entry
881 [ $(basename "${file}") = "register
" ] && continue
882 # Search for the file with the correct magic value.
883 grep -qE "^magic
${magic}$
" "${file}" || continue
885 local interpreter="$
(grep "^interpreter" "${file}" |
awk '{ print $2 }')"
887 [ -n "${interpreter}" ] || continue
888 [ "${interpreter:0:1}" = "/" ] || continue
889 [ -x "${interpreter}" ] || continue
891 echo "${interpreter}"
901 file ${file} 2>/dev/null | grep -q "statically linked
"
904 update_language_list() {
908 for lang in ${path}/*.po; do
909 lang="$
(basename "${lang}")"
911 done | sort -u > "${path}/LINGUAS
"
917 git shortlog --summary --numbered | while read -r commits name; do
919 done | grep -vE -e "^
(alpha197|morlix|root|ummeegge
)$
" -e "via Development$
" -e "@
" -e "#$"
922 update_contributors
() {
923 echo -n "Updating list of contributors"
925 local contributors
="$(contributors | paste -sd , - | sed -e "s
/,/&\\\\n
/g
")"
927 # Edit contributors into credits.cgi
928 local tmp
="$(mktemp)"
930 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
931 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
933 # Copy back modified content
934 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
942 CCACHE_CACHE_SIZE
="4G"
943 ENABLE_RAMDISK
="auto"
945 # Load configuration file
946 if [ -f .config
]; then
950 # TARGET_ARCH is BUILD_ARCH now
951 if [ -n "${TARGET_ARCH}" ]; then
952 BUILD_ARCH
="${TARGET_ARCH}"
956 # Get some information about the host system
957 SYSTEM_PROCESSORS
="$(system_processors)"
958 SYSTEM_MEMORY
="$(system_memory)"
960 if [ -n "${BUILD_ARCH}" ]; then
961 configure_build
"${BUILD_ARCH}"
963 configure_build
"default"
966 # Automatically enable/disable ramdisk usage
967 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
968 # Enable only when the host system has 4GB of RAM or more
969 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
976 case "${BUILD_ARCH}:${HOST_ARCH}" in
983 i586
:i586|i586
:i686|i586
:x86_64
)
991 arvm7hl
:armv7hl|armv7hl
:armv7l
)
995 armv5tel
:armv5tel|armv5tel
:armv5tejl|armv5tel
:armv6l|armv5tel
:armv7l|armv5tel
:aarch64
)
1004 exiterror
"Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1006 local gcc
=$
(type -p gcc
)
1007 if [ -z "${gcc}" ]; then
1008 exiterror
"Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1011 # Check ${TOOLS_DIR} symlink
1012 if [ -h "${TOOLS_DIR}" ]; then
1013 rm -f "${TOOLS_DIR}"
1016 if [ ! -e "${TOOLS_DIR}" ]; then
1017 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1020 if [ ! -h "${TOOLS_DIR}" ]; then
1021 exiterror
"Could not create ${TOOLS_DIR} symbolic link"
1024 LOGFILE
="$BASEDIR/log/_build.toolchain.log"
1028 lfsmake1 ccache PASS
=1
1029 lfsmake1 binutils PASS
=1
1031 lfsmake1 linux KCFG
="-headers"
1034 lfsmake1 binutils PASS
=2
1037 lfsmake1 ccache PASS
=2
1064 lfsmake1 fake-environ
1066 lfsmake1 cleanup-toolchain
1070 LOGFILE
="$BASEDIR/log/_build.base.log"
1073 lfsmake2 linux KCFG
="-headers"
1077 lfsmake2 cleanup-toolchain
1090 lfsmake2 berkeley-compat
1100 lfsmake2 readline-compat
1104 lfsmake2 pcre-compat
1139 LOGFILE
="$BASEDIR/log/_build.ipfire.log"
1142 lfsmake2 initscripts
1145 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG
='-sse2'
1151 lfsmake2 libusb-compat
1157 lfsmake2 linux-firmware
1158 lfsmake2 dvb-firmwares
1159 lfsmake2 xr819-firmware
1160 lfsmake2 zd1211-firmware
1161 lfsmake2 rpi-firmware
1162 lfsmake2 intel-microcode
1163 lfsmake2 pcengines-apu-firmware
1165 lfsmake2 u-boot MKIMAGE
=1
1171 lfsmake2 multipath-tools
1174 lfsmake2 libnfnetlink
1175 lfsmake2 libnetfilter_queue
1176 lfsmake2 libnetfilter_conntrack
1177 lfsmake2 libnetfilter_cthelper
1178 lfsmake2 libnetfilter_cttimeout
1183 case "${BUILD_ARCH}" in
1185 lfsmake2 linux KCFG
=""
1186 # lfsmake2 backports KCFG=""
1187 # lfsmake2 e1000e KCFG=""
1188 # lfsmake2 igb KCFG=""
1189 # lfsmake2 ixgbe KCFG=""
1190 lfsmake2 xtables-addons KCFG
=""
1191 lfsmake2 linux-initrd KCFG
=""
1195 lfsmake2 linux KCFG
=""
1196 # lfsmake2 backports KCFG=""
1197 # lfsmake2 e1000e KCFG=""
1198 # lfsmake2 igb KCFG=""
1199 # lfsmake2 ixgbe KCFG=""
1200 lfsmake2 xtables-addons KCFG
=""
1201 lfsmake2 linux-initrd KCFG
=""
1205 # arm multi platform (Panda, Wandboard ...) kernel build
1206 lfsmake2 linux KCFG
="-multi"
1207 # lfsmake2 backports KCFG="-multi"
1208 # lfsmake2 e1000e KCFG="-multi"
1209 # lfsmake2 igb KCFG="-multi"
1210 # lfsmake2 ixgbe KCFG="-multi"
1211 lfsmake2 xtables-addons KCFG
="-multi"
1212 lfsmake2 linux-initrd KCFG
="-multi"
1215 lfsmake2 xtables-addons USPACE
="1"
1216 lfsmake2 libgpg-error
1245 lfsmake2 ca-certificates
1255 lfsmake2 libjpeg-compat
1277 lfsmake2 web-user-interface
1286 lfsmake2 reiserfsprogs
1295 lfsmake2 GD-TextUtil
1296 lfsmake2 perl-Device-SerialPort
1297 lfsmake2 perl-Device-Modem
1298 lfsmake2 perl-Apache-Htpasswd
1299 lfsmake2 perl-Parse-Yapp
1306 lfsmake2 conntrack-tools
1310 lfsmake2 l7-protocols
1318 lfsmake2 perl-Switch
1319 lfsmake2 HTML-Tagset
1320 lfsmake2 HTML-Parser
1321 lfsmake2 HTML-Template
1322 lfsmake2 Compress-Zlib
1324 lfsmake2 Digest-SHA1
1325 lfsmake2 Digest-HMAC
1326 lfsmake2 libwww-perl
1328 lfsmake2 Net-IPv4Addr
1331 lfsmake2 IO-Socket-SSL
1332 lfsmake2 Unix-Syslog
1336 lfsmake2 Convert-TNEF
1337 lfsmake2 Convert-UUlib
1338 lfsmake2 Archive-Tar
1339 lfsmake2 Archive-Zip
1340 lfsmake2 Text-Tabs
+Wrap
1342 lfsmake2 Crypt-PasswdMD5
1344 lfsmake2 python-setuptools
1345 lfsmake2 python-clientform
1346 lfsmake2 python-mechanize
1347 lfsmake2 python-feedparser
1348 lfsmake2 python-rssdler
1349 lfsmake2 python-inotify
1350 lfsmake2 python-docutils
1351 lfsmake2 python-daemon
1352 lfsmake2 python-ipaddress
1357 lfsmake2 dejavu-fonts-ttf
1358 lfsmake2 ubuntu-font-family
1375 lfsmake2 ids-ruleset-sources
1396 lfsmake2 ghostscript
1399 lfsmake2 poppler-data
1400 lfsmake2 cups-filters
1401 lfsmake2 epson-inkjet-printer-escpr
1406 lfsmake2 rpcsvc-proto
1412 lfsmake2 bridge-utils
1413 lfsmake2 smartmontools
1419 lfsmake2 perl-NetAddr-IP
1420 lfsmake2 spamassassin
1421 lfsmake2 perl-Net-LibIDN
1443 lfsmake2 libnfsidmap
1455 lfsmake2 pcmciautils
1464 lfsmake2 python-pyparsing
1465 lfsmake2 spice-protocol
1468 lfsmake2 libusbredir
1474 lfsmake2 nagios_nrpe
1475 lfsmake2 nagios-plugins
1477 lfsmake2 observium-agent
1483 lfsmake2 vdr_streamdev
1484 lfsmake2 vdr_epgsearch
1489 lfsmake2 libmpdclient
1491 lfsmake2 perl-Net-CIDR-Lite
1492 lfsmake2 perl-Net-SMTP-SSL
1493 lfsmake2 perl-MIME-Base64
1494 lfsmake2 perl-Authen-SASL
1495 lfsmake2 perl-MIME-Lite
1496 lfsmake2 perl-Email-Date-Format
1498 lfsmake2 squidclamav
1501 lfsmake2 wpa_supplicant
1507 lfsmake2 cpufrequtils
1517 lfsmake2 perl-gettext
1518 lfsmake2 perl-Sort-Naturally
1521 lfsmake2 perl-DBD-SQLite
1522 lfsmake2 perl-File-ReadBackwards
1523 lfsmake2 openvmtools
1524 lfsmake2 libmicrohttpd
1533 lfsmake2 usb_modeswitch
1534 lfsmake2 usb_modeswitch_data
1544 lfsmake2 u-boot-friendlyarm
1545 lfsmake2 python-typing
1546 lfsmake2 python-m2crypto
1547 lfsmake2 wireless-regdb
1550 lfsmake2 python-distutils-extra
1551 lfsmake2 python-lzma
1552 lfsmake2 python-progressbar
1553 lfsmake2 python-xattr
1555 lfsmake2 python3-setuptools
1556 lfsmake2 python3-setuptools-scm
1557 lfsmake2 python3-six
1558 lfsmake2 python3-dateutil
1559 lfsmake2 python3-jmespath
1560 lfsmake2 python3-colorama
1561 lfsmake2 python3-docutils
1562 lfsmake2 python3-yaml
1563 lfsmake2 python3-s3transfer
1564 lfsmake2 python3-rsa
1565 lfsmake2 python3-pyasn1
1566 lfsmake2 python3-botocore
1567 lfsmake2 python3-llfuse
1568 lfsmake2 python3-msgpack
1570 lfsmake2 transmission
1583 lfsmake2 libstatgrab
1590 lfsmake2 ipfire-netboot
1594 lfsmake2 perl-Carp-Clan
1595 lfsmake2 perl-Date-Calc
1596 lfsmake2 perl-Date-Manip
1597 lfsmake2 perl-File-Tail
1598 lfsmake2 perl-TimeDate
1606 lfsmake2 perl-Font-TTF
1607 lfsmake2 perl-IO-String
1608 lfsmake2 perl-PDF-API2
1609 lfsmake2 squid-accounting
1612 lfsmake2 perl-Text-CSV_XS
1621 lfsmake2 util-macros
1622 lfsmake2 libpciaccess
1627 lfsmake2 perl-common-sense
1628 lfsmake2 perl-inotify2
1629 lfsmake2 perl-Net-IP
1632 lfsmake2 mdns-repeater
1634 lfsmake2 nss-myhostname
1636 lfsmake2 shairport-sync
1640 lfsmake2 spectre-meltdown-checker
1641 lfsmake2 zabbix_agentd
1643 lfsmake2 firmware-update
1645 lfsmake2 speedtest-cli
1647 lfsmake2 amazon-ssm-agent
1654 # Run installer scripts one by one
1655 LOGFILE
="$BASEDIR/log/_build.installer.log"
1659 # use toolchain bash for chroot to strip
1660 EXTRA_PATH
=${TOOLS_DIR}/bin
/ lfsmake2 strip
1664 LOGFILE
="$BASEDIR/log/_build.packages.log"
1666 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1669 # Generating list of packages used
1670 print_line
"Generating packages list from logs"
1671 rm -f $BASEDIR/doc
/packages-list
1672 for i
in `ls -1tr $BASEDIR/log/[^_]*`; do
1673 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1674 echo "* `basename $i`" >>$BASEDIR/doc
/packages-list
1677 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc
/packages-list.txt
1678 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1679 $BASEDIR/doc
/packages-list |
sort >> $BASEDIR/doc
/packages-list.txt
1680 rm -f $BASEDIR/doc
/packages-list
1681 # packages-list.txt is ready to be displayed for wiki page
1686 [ -z $GIT_TAG ] || LAST_TAG
=$GIT_TAG
1687 [ -z $LAST_TAG ] || EXT
="$LAST_TAG..HEAD"
1688 git log
-n 500 --no-merges --pretty=medium
--shortstat $EXT > $BASEDIR/doc
/ChangeLog
1690 # Create images for install
1693 # Check if there is a loop device for building in virtual environments
1694 modprobe loop
2>/dev
/null
1695 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev
/loop
/0 ] ||
[ -e /dev
/loop0
] ||
[ -e "/dev/loop-control" ]); then
1696 lfsmake2 flash-images
1699 mv $LFS/install
/images
/{*.iso
,*.img.xz
,*.bz2
} $BASEDIR >> $LOGFILE 2>&1
1705 # remove not useable iso on armv5tel (needed to build flash images)
1706 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1708 for i
in $
(ls *.bz2
*.img.xz
*.iso
2>/dev
/null
); do
1715 rm -rf $BASEDIR/build
/tmp
/*
1721 lfsmake2 core-updates
1724 for i
in $
(find $BASEDIR/config
/rootfiles
/packages
{/${BUILD_ARCH},} -maxdepth 1 -type f
); do
1726 if [ -e $BASEDIR/lfs
/$i ]; then
1733 test -d $BASEDIR/packages || mkdir
$BASEDIR/packages
1734 mv -f $LFS/install
/packages
/* $BASEDIR/packages
>> $LOGFILE 2>&1
1735 rm -rf $BASEDIR/build
/install
/packages
/*
1738 while [ $# -gt 0 ]; do
1741 configure_build
"${1#--target=}"
1744 exiterror
"Unknown configuration option: ${1}"
1747 # Found a command, so exit options parsing.
1754 # See what we're supposed to do
1760 ${INTERACTIVE} && clear
1762 PACKAGE
=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1763 #only restore on a clean disk
1764 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1765 if [ ! -n "$PACKAGE" ]; then
1766 print_build_stage
"Full toolchain compilation"
1770 PACKAGENAME
=${PACKAGE%.tar.xz}
1771 print_build_stage
"Packaged toolchain compilation"
1772 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1776 exiterror
"$PACKAGENAME md5 did not match, check downloaded package"
1783 print_build_stage
"Building LFS"
1786 print_build_stage
"Building IPFire"
1789 print_build_stage
"Building installer"
1792 print_build_stage
"Building packages"
1795 print_build_stage
"Checking Logfiles for new Files"
1798 tools
/checknewlog.pl
1799 tools
/checkrootfiles
1802 print_build_summary $
(( $
(now
) - ${START_TIME} ))
1805 # enter a shell inside LFS chroot
1806 # may be used to changed kernel settings
1811 print_line
"Cleaning build directory..."
1813 for i
in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1814 $LOSETUP -d $i 2>/dev
/null
1816 for i
in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1820 for i
in `seq 0 7`; do
1821 if ( losetup
/dev
/loop
${i} 2>/dev
/null |
grep -q "/install/images" ); then
1822 umount
/dev
/loop
${i} 2>/dev
/null
;
1823 losetup
-d /dev
/loop
${i} 2>/dev
/null
;
1826 rm -rf $BASEDIR/build
1827 rm -rf $BASEDIR/cdrom
1828 rm -rf $BASEDIR/packages
1830 if [ -h "${TOOLS_DIR}" ]; then
1831 rm -f "${TOOLS_DIR}"
1833 rm -f $BASEDIR/ipfire-
*
1837 # Build the docker image if it does not exist, yet
1838 if ! docker images
-a |
grep -q ^ipfire-builder
; then
1839 if docker build
-t ipfire-builder
${BASEDIR}/tools
/docker
; then
1847 # Run the container and enter a shell
1848 docker run
-it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash
-l
1851 if [ ! -d $BASEDIR/cache
]; then
1852 mkdir
$BASEDIR/cache
1854 mkdir
-p $BASEDIR/log
1855 echo -e "${BOLD}Preload all source files${NORMAL}" |
tee -a $LOGFILE
1858 for c
in `seq $MAX_RETRIES`; do
1859 if (( FINISHED
==1 )); then
1865 if [ -f "$i" -a "$i" != "Config" ]; then
1866 lfsmakecommoncheck
${i} ||
continue
1868 make -s -f $i LFS_BASEDIR
=$BASEDIR BUILD_ARCH
="${BUILD_ARCH}" \
1869 MESSAGE
="$i\t ($c/$MAX_RETRIES)" download
>> $LOGFILE 2>&1
1870 if [ $?
-ne 0 ]; then
1874 if [ $c -eq 1 ]; then
1881 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1884 if [ -f "$i" -a "$i" != "Config" ]; then
1885 lfsmakecommoncheck
${i} > /dev
/null ||
continue
1886 make -s -f $i LFS_BASEDIR
=$BASEDIR BUILD_ARCH
="${BUILD_ARCH}" \
1887 MESSAGE
="$i\t " md5
>> $LOGFILE 2>&1
1888 if [ $?
-ne 0 ]; then
1889 echo -ne "MD5 difference in lfs/$i"
1895 if [ $ERROR -eq 0 ]; then
1896 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1899 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1902 cd - >/dev
/null
2>&1
1906 ${INTERACTIVE} && clear
1909 print_build_stage
"Toolchain compilation (${BUILD_ARCH})"
1911 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" |
tee -a $LOGFILE
1912 test -d $BASEDIR/cache
/toolchains || mkdir
-p $BASEDIR/cache
/toolchains
1913 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build
/${TOOLS_DIR} build
/bin
/sh log | xz
${XZ_OPT} \
1914 > cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.
tar.xz
1915 md5sum cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.
tar.xz \
1916 > cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1920 # arbitrary name to be updated in case of new toolchain package upload
1921 PACKAGE
=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1922 if [ ! -f $BASEDIR/cache
/toolchains
/$PACKAGE.
tar.xz
]; then
1923 URL_TOOLCHAIN
=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1924 test -d $BASEDIR/cache
/toolchains || mkdir
-p $BASEDIR/cache
/toolchains
1925 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" |
tee -a $LOGFILE
1926 cd $BASEDIR/cache
/toolchains
1927 wget
-U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.
tar.xz
$URL_TOOLCHAIN/$PACKAGE.md5
>& /dev
/null
1928 if [ $?
-ne 0 ]; then
1929 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" |
tee -a $LOGFILE
1931 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1932 echo "`date -u '+%b %e %T'`: toolchain md5 ok" |
tee -a $LOGFILE
1934 exiterror
"$PACKAGE.md5 did not match, check downloaded package"
1938 echo "Toolchain is already downloaded. Exiting..."
1943 if [ -z $IPFIRE_USER ]; then
1944 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1949 URL_SOURCE
=$
(grep URL_SOURCE lfs
/Config |
awk '{ print $3 }')
1950 REMOTE_FILES
=$
(echo "ls -1" | sftp
-C ${IPFIRE_USER}@
${URL_SOURCE})
1952 for file in ${BASEDIR}/cache
/*; do
1953 [ -d "${file}" ] && continue
1954 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1955 NEW_FILES
="$NEW_FILES $file"
1957 [ -n "$NEW_FILES" ] && scp
-2 $NEW_FILES ${IPFIRE_USER}@
${URL_SOURCE}
1963 echo -ne "Checking the translations for missing or obsolete strings..."
1964 chmod 755 $BASEDIR/tools
/{check_strings.pl
,sort_strings.pl
,check_langs.sh
}
1965 $BASEDIR/tools
/sort_strings.pl en
1966 $BASEDIR/tools
/sort_strings.pl de
1967 $BASEDIR/tools
/sort_strings.pl fr
1968 $BASEDIR/tools
/sort_strings.pl es
1969 $BASEDIR/tools
/sort_strings.pl pl
1970 $BASEDIR/tools
/sort_strings.pl ru
1971 $BASEDIR/tools
/sort_strings.pl
nl
1972 $BASEDIR/tools
/sort_strings.pl
tr
1973 $BASEDIR/tools
/sort_strings.pl it
1974 $BASEDIR/tools
/check_strings.pl en
> $BASEDIR/doc
/language_issues.en
1975 $BASEDIR/tools
/check_strings.pl de
> $BASEDIR/doc
/language_issues.de
1976 $BASEDIR/tools
/check_strings.pl fr
> $BASEDIR/doc
/language_issues.fr
1977 $BASEDIR/tools
/check_strings.pl es
> $BASEDIR/doc
/language_issues.es
1978 $BASEDIR/tools
/check_strings.pl es
> $BASEDIR/doc
/language_issues.pl
1979 $BASEDIR/tools
/check_strings.pl ru
> $BASEDIR/doc
/language_issues.ru
1980 $BASEDIR/tools
/check_strings.pl
nl > $BASEDIR/doc
/language_issues.
nl
1981 $BASEDIR/tools
/check_strings.pl
tr > $BASEDIR/doc
/language_issues.
tr
1982 $BASEDIR/tools
/check_strings.pl it
> $BASEDIR/doc
/language_issues.it
1983 $BASEDIR/tools
/check_langs.sh
> $BASEDIR/doc
/language_missings
1986 echo -ne "Updating language lists..."
1987 update_language_list
${BASEDIR}/src
/installer
/po
1988 update_language_list
${BASEDIR}/src
/setup
/po
1991 update-contributors
)
1996 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
1999 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies}"
2000 cat doc
/make.sh-usage